// #LANCEMENT#
var divgl=document.createElement('div');
document.body.appendChild(divgl);

calcDim();
initDivMenu();

var hGL=Math.round(window.hFen*0.6);
var lGL=hGL;

var canv = document.createElement('canvas');
canv.width  = lGL;
canv.height  = hGL;
canv.style.zIndex   = 2;
canv.style.position = "absolute";
divgl.appendChild(canv)
var ctx = canv.getContext("2d");

var divpadding=Math.round(hGL/16);
var lBG=lGL-divpadding*2;
var hBG=(hFen-hGL)+hMenu0;
var fsBG=Math.floor(hBG/18*100)/100;
var fsD=Math.floor(hBG/15*100)/100;
var xDivD=lGL+xFen;
var lDivD=(lFen-lGL-divpadding*2);
var hDivD=(hFen);

var divbg=document.getElementById('divbg');
var divd=document.getElementById('divd');

divd.style.position = "absolute";
divd.style.paddingLeft = divpadding+"px";
divd.style.paddingRight = divpadding+"px";
divd.style.left = xDivD+"px";
divd.style.top = yFen+"px";
divd.style.width=lDivD+"px";
divd.style.height=hDivD+"px";
divd.style.fontSize=fsD+"px";

divgl.style.position = "absolute";
divgl.style.padding = 0+"px";
divgl.style.left = xFen+"px";
divgl.style.top = 0+"px";
divgl.style.width=lGL+"px";
divgl.style.height=hGL+"px";
divgl.style.zIndex=0;
divgl.style.cursor="crosshair";

divbg.style.position = "absolute";
divbg.style.paddingLeft = divpadding+"px";
divbg.style.paddingRight = divpadding+"px";
divbg.style.left = xFen+"px";
divbg.style.top = hGL+"px";
divbg.style.backgroundColor="black";
divbg.style.width=lBG+"px";
divbg.style.height=hBG+"px";
divbg.style.fontSize=fsBG+"px";
document.body.style.fontSize=fsBG+"px";

divgl.addEventListener('mousemove',mousemoveGL);
divgl.addEventListener('mouseout',function () {document.getElementById("divtemper").innerHTML=""});

setTimeout(function(){
	init_menu();
	initMolette ();
	remplitTableau();
	initAnim();
	divbg.style.display = "block";
	divd.style.display = "block";
	divgl.style.display = "block";
	divmenu.style.display = "block";
	rafrTextMenu();
},20)

function mousemoveGL(event) {
	let dt=document.getElementById("divtemper");
	let x = event.clientX;
	let y = event.clientY;
	dt.style.left=x+fsBG*0.5+"px";
	dt.style.top=y-fsBG*1.5+"px";
	x-= this.offsetLeft ; 
	y-=this.offsetTop ;
	x-=lGL/2;
	y-=hGL/2;
	let xr=x/lGL*zoom;
	let yr=y/hGL*zoom;
	let d2=xr*xr+yr*yr;
	let d=Math.sqrt(d2);
	if (d<1) {dt.innerHTML="";return false;}
	let dUA=d/150;
	d2=dUA*dUA;
	let alb=0.35;
	let tt=280* Math.pow(((1-alb)/d2),0.25);
	tt-=273.15;
	dt.innerHTML=Math.round(tt)+"°C";
	//console.log (d,tt);
}

function initMolette () {
	// for mouse scrolling in Firefox
	var elem =divgl;
	if (elem.addEventListener) {    // all browsers except IE before version 9
			// Internet Explorer, Opera, Google Chrome and Safari
		elem.addEventListener ("mousewheel", molette, false);
			// Firefox
		elem.addEventListener ("DOMMouseScroll", molette, false);
	}
	else {
		if (elem.attachEvent) { // IE before version 9
			elem.attachEvent ("onmousewheel", molette);
		}
	}
	var elem =divbg;
	if (elem.addEventListener) {    // all browsers except IE before version 9
			// Internet Explorer, Opera, Google Chrome and Safari
		elem.addEventListener ("mousewheel", molette, false);
			// Firefox
		elem.addEventListener ("DOMMouseScroll", molette, false);
	}
	else {
		if (elem.attachEvent) { // IE before version 9
			elem.attachEvent ("onmousewheel", molette);
		}
	}
}


function molette(e) {
	// cross-browser wheel delta
	var vZoom=1.1;
	var e = window.event || e; // old IE support
	var delta = Math.max(-1, Math.min(1, (e.wheelDelta || -e.detail)));
	if (delta<0)
	{
		zoom=zoom*vZoom;
		if (zoom>12000) {zoom=12000;}
	}
	else if (delta>0)
	{
		zoom=zoom/vZoom;
		if (zoom<20) {zoom=20;}
	}	
	document.getElementById("divtemper").innerHTML="";
}

idPage="temper";
var rOrb=new Array();
rOrb=[59,108,150,225,780,1425,2880,4515];
rSoleil=0.7;

var mode=0;

var vitSoleil=27;

var tCoul=new Array();
tCoul=[0x555555,0x778833,0x0088AA,0xAA5500,0xAA7733,0x999977,0x2244CC,0x1122AA];

var tTemp=[169,462,15,-63,-148,-180,-212,-215];
var tAlb=[0.12,0.65,0.35,0.16,0.52,0.47,0.51,0.41];

var tTempTh=[];
for (var i=0;i<tAlb.length;i++) {
	let alb=tAlb[i];
	let d=rOrb[i];
	let dUA=d/150;
	let d2=dUA*dUA;
	let tt=280* Math.pow(((1-alb)/d2),0.25);
	tt-=273.15;
	tTempTh[i]=Math.round(tt);
}

var nomPla=new Array();
nomPla=['Mercure','Vénus','Terre','Mars','Jupiter','Saturne','Uranus','Neptune'];

var anglePla=0;
var timer;

var zoom=1600;
var temps=0;
var vitesse;

function initAnim() {
	timer=setInterval(function () {tempsPasse()}, 50);
}


function remplitTableau () {
	var texte="";
	texte+="<table class='tableauPerio'><tr><th width='1%'></th><th>Nom</th><th>Albédo</th><th>Température théorique<br>(°C)</th><th>Température moyenne<br>mesurée (°C)</th></tr>";
	for (var i=0;i<rOrb.length;i++) {
		texte+="<tr><td width='1%' bgcolor='#"+decimalToHex(tCoul[i],6)+"'></td><td>"+nomPla[i]+"</td><td>"+(tAlb[i]+"").replace(".",",")+"</td><td>"+tTempTh[i]+"</td><td>"+tTemp[i]+"</td></tr>";
	}
	texte+="</table>";
	
	divbg.innerHTML+=texte;
}


function tempsPasse() {
	temps+=Math.exp(vitesse)/2;
	dessineEllipse();
}

function dessineEllipse() {
	// on ne dessine ici que les orbites
	ctx.fillStyle="black";
	ctx.fillRect(0,0,lGL,hGL);
	var x0=Math.round(lGL/2);
	var y0=Math.round(hGL/2);
	var rPla=lGL*0.01;
	ctx.fillStyle="yellow";
	var r=rSoleil/zoom*lGL;
	ctx.beginPath();
	ctx.arc(x0,y0,r,0,Math.PI*2);
	ctx.closePath;
	ctx.fill();

	
	for (var i=0;i<rOrb.length;i++) {
		var r=rOrb[i]/zoom*lGL;
		ctx.strokeStyle="#"+decimalToHex(tCoul[i],6);
		ctx.beginPath();
		ctx.arc(x0,y0,r,0,Math.PI*2);
		ctx.closePath;
		ctx.stroke();
	}
	
	//	texte
	var fs=Math.round(lGL*0.25)/10;
	ctx.font="italic "+fs+"px Arial";
	ctx.textAlign="center";
	ctx.fillStyle="#aaaaaa";
	ctx.fillText("Utiliser la molette de la souris pour zoomer",x0,hGL-fs*0.5);
	ctx.fillText("Survoler avec la souris pour afficher la",x0,hGL-fs*4);
	ctx.fillText("température théorique correspondant à un albedo de 0,35",x0,hGL-fs*2.8);
}